SystemOrganization addCategory: #'GT-InspectorExtensions-Core'!

!Bag methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:48'!
gtInspectorOccurrencesIn: composite
	<gtInspectorPresentationOrder: 1>  
	^ (composite table)
		title: 'Occurrences';
		display: [ :aCollection | self asSet ];
		column: 'Item' 
			evaluated: [ :each | GTObjectPrinter new asTruncatedTextFrom: each ];
		column: 'Occurences' 
			evaluated: [ :each | self occurrencesOf: each ];
		beMultiple;
		withSmalltalkSearch;
		showOnly: 50;
		send: [ :result | 
				result isNil 
				ifTrue:[nil] 
				ifFalse:[ (result size = 1)
					ifTrue: [result anyOne] 
					ifFalse: [self species withAll: result]]];
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!GLMSystemWindow class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:02'!
gtExampleEmptyBrowser
	<gtExample>
	^ self new model: GLMBrowser new! !

!GLMTabulator class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:05'!
gtExampleSimple
	<gtExample>
	^ GLMTabulator new 
		with: [ :t |
			t column: #one.
			t transmit to: #one; andShow: [ :a | a text] ];
		startOn: 42! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 20:53'!
allProjects
	| all |
	all := OrderedCollection new.
	self allProjectsDo: [ :each |
		all add: each ].
	^ all! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 21:01'!
allProjectsDo: aBlock
	self allProjectsDo: aBlock withTraversedProjects: OrderedCollection new! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 21:30'!
allProjectsDo: aBlock withTraversedProjects: aCollection
	self projects do: [ :each |
		(each version notNil and: [(aCollection includes: each version) not]) 
		ifTrue: [
			aCollection add: each version.
			aBlock value: each version.
			each version allProjectsDo: aBlock withTraversedProjects: aCollection ] ]! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/14/2014 21:58'!
gtInspectorPackagesIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Packages';
		display: [ self spec packages packageSpecsInLoadOrder select: [ :each | 
				each isKindOf: MetacelloPackageSpec ] ]! !

!MetacelloVersion methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/13/2014 08:34'!
gtInspectorProjectsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Projects';
		display: [ self projects ]! !

!ComposableModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/2/2013 16:38'!
gtInspectorModelNestingIn: composite
	<gtInspectorPresentationOrder: 20>
	composite tree 
		title: 'Nesting';
		display: [ :root | { 'root' -> self } ];
		children: [ :each | 
			each value class allInstVarNames 
				collect: [ :iv | iv->(each value instVarNamed: iv) ]
				thenSelect: [ :association | 
					(association value isKindOf: ComposableModel) 
						and: [ (#('owner' 'window') includes: association key) not ] ] ];
		format: [ :association | association key , ': ' , association value asString ];
		send: #value! !

!ComposableModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/5/2014 11:59'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 30>
	
	(self widget notNil and: [ self widget widget notNil ]) ifTrue: [ 
		 self widget widget gtInspectorMorphIn: composite ].! !

!Morph class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:20'!
gtExampleEmpty
	<gtExample>
	<label: 'Empty'>
	
	^ self new! !

!Morph class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:20'!
gtExampleSubmorphs
	<gtExample>
	<label: 'Submorphs'>
	
	^ self new
		addMorph: self new;
		addMorph: self new;
		yourself! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/22/2015 19:03'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 95>
	(self hasProperty: #kmDispatcher) ifFalse: [^self].
	self kmDispatcher gtInspectorMappingsIn: composite! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/27/2014 20:31'!
gtInspectorMorphExtensionIn: composite
	<gtInspectorPresentationOrder: 15>
	^ composite table
		title: 'Extension';
		showOnly: 50; 
		display: [ self extension gtInspectorVariableValuePairs asSortedCollection ];
		column: 'Variable' 
			evaluated: [:assoc | GTObjectPrinter new asNonTruncatedTextFrom: assoc key ];
		column: 'Value' 
			evaluated: [:assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ];
		send: #value;
		morphicSelectionAct: [:list | list selection value browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			on: $b 
			entitled: 'Browse';
		morphicSelectionAct: [:list | list selection value inspect ] 
			icon: GLMUIThemeExtraIcons glamorousInspect 
			on: $i 
			entitled: 'Inspect';
		selectionAct: [:list | 
			((list selection pointersToExcept: { list selection })
									reject: [ :each | each pointsOnlyWeaklyTo: list selection ]) inspect ] 
			on: $t
			entitled: 'Open pointers to'! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/19/2015 11:03'!
gtInspectorMorphIn: composite
	<gtInspectorPresentationOrder: 90>  
	| morphPresentation |
	morphPresentation := composite morph.
	morphPresentation 
		title: 'Morph';
		display: [
			[self imageForm asMorph
				on: #mouseDown send: #value: to: [ :event | 
					morphPresentation selection: (self morphsAt: event position) ]] on:Error
			do:[IconicListItem text:'Error drawing Morph' icon:Smalltalk ui icons smallWarningIcon] ];
		act: [ :pres | self exportAsPNG ] entitled: 'Export as PNG';
		act: [ :pres | self delete ] entitled: 'Delete'! !

!Morph methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/19/2015 10:58'!
gtInspectorSubmorphsIn: composite
	<gtInspectorPresentationOrder: 80>  
	composite tree 
		title: 'Submorphs';
		rootsExpanded;
		display: [:each | {each} ];
		icon: [:each | | morphForm |
			morphForm := each imageForm.
			(morphForm extent x > 0 and: [morphForm extent y > 0 ])
				ifTrue: [(morphForm scaledToSize: 16@16) asMorph]
				ifFalse: [Form extent: 16@16] ];
		children: [:each | each submorphs];
		when: [:each | each submorphs notNil and:[ each hasSubmorphs ] ]! !

!SmallDictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:52'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: 'Items';
		display: [ self associations ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		selectionAct: [ :table |
			table rawSelection do: [ :assoc | self removeKey: assoc key ].
			table update ]
			entitled: 'Remove item(s)';
		selectionPopulate: #selection 
			entitled: 'Open key'
			with: [ :table | (table rawSelection collect: #key) gtInspectorInterestingObject ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | selection isNil 
			ifTrue:[nil]
			ifFalse:[ (selection size = 1 ) 
				ifTrue: [ selection anyOne value ] 
				ifFalse: [ selection collect: #value ] ]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!SettingNode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/22/2015 18:44'!
gtInspectorLiveIn: composite
	<gtInspectorPresentationOrder: 0>
	composite morph
		title: 'Live';
		display: [ self settingDeclaration inputWidget ];
		when: [ self settingDeclaration notNil and: [ self settingDeclaration inputWidget notNil ] ]! !

!ZnStatusLine class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleForbidden
	<gtExample>
	<label: 'Forbidden'>
	
	^ self forbidden! !

!ZnStatusLine class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleNotFound
	<gtExample>
	<label: 'Not Found'>
	
	^ self notFound! !

!ZnStatusLine class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleOk
	<gtExample>
	<label: 'Ok'>
	
	^ self ok! !

!ZnStatusLine methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 15:19'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite rubricText
		title: 'HTTP';
		format: [ String streamContents: [ :out | self writeOn: out ] ]! !

!IRMethod class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 17:33'!
gtExampleNewMethod
	<gtExample>
	^ IRBuilder new 
		addTemps: #(a);
		pushReceiver;
		pushLiteral: 1;
		storeTemp: #a;
		ir! !

!IRMethod class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 17:33'!
gtExampleThisMethod
	<gtExample>
	^ (self class >> #gtExampleThisMethod) ast ir! !

!SymbolicBytecode class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:26'!
gtExampleSymbolicBytecode
	<gtExample>
	<label: 'Symbolic Bytecode'>
	
	^ (SymbolicBytecode class >> #gtExampleSymbolicBytecode) symbolicBytecodes anyOne! !

!Set class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:26'!
gtExampleSimple
	<gtExample>
	<label: 'Simple'>
	
	^ #('fourtytwo' 42) asSet! !

!Set methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 5/30/2012 06:49'!
gtInspectorItemsIn: composite
	"we override this because sets do not work well in morph tree morphs" 
	^ (super gtInspectorItemsIn: composite)
		display: [:set | set asOrderedCollection]! !

!CompiledMethod class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtExampleSimple
	<gtExample>
	^ self class>>#gtExampleSimple! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 3/25/2015 09:48'!
gtDisplayOn: aStream
	aStream print: self methodClass; nextPutAll: '>>'; store: self selector.! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/14/2014 10:52'!
gtInspectorASTIn: composite
	<gtInspectorPresentationOrder: 35> 
	(GTSimpleRBTreeBrowser new treeIn: composite)
		title: 'AST';
		display: [ :anObject | {anObject ast} ]
		! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'MarcusDenker 3/11/2015 17:16'!
gtInspectorBytecodeIn: composite
	<gtInspectorPresentationOrder: 30> 
	^ (GTBytecodeBrowser new treeIn: composite)
		title: 'Bytecode'! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/15/2014 09:41'!
gtInspectorBytesIn: composite
	<gtInspectorPresentationOrder: 30>
	"It makes no sense to view me as a collection of bytes"! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'MarcusDenker 3/11/2015 17:13'!
gtInspectorHeaderIn: composite
	<gtInspectorPresentationOrder: 40> 
	composite text 
		title: 'Header';
		display: [ self headerDescription ]! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 12/19/2013 16:33'!
gtInspectorIrIn: composite
	<gtInspectorPresentationOrder: 35> 
	composite text 
		title: 'Ir';
		display: [ :anObject || string |
				string := anObject ir longPrintString.
				string copyFrom: 2 to: string size ]! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/15/2014 09:42'!
gtInspectorItemsIn: composite
	"It makes no sense to view me as a collection of items"! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/29/2014 17:56'!
gtInspectorPragmasIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite tabulator 
		title: 'Pragmas';
		when: [ :x | x pragmas notEmpty ];
		with: [ :t |  
			t row: #pragmas; row: #methods.
			t transmit to: #pragmas; andShow: [:a | 
				a list
					title: 'Pragmas';
					display: [ :method | method pragmas ];
					when: [ :x | x pragmas notEmpty ] ].
			t transmit from: #pragmas; to: #methods; andShow: [:a | 
				a list 
					title: 'Methods';
					display: [ :pragma | 
						| methods | 
						methods := OrderedCollection new.
						Object withAllSubclassesDo: [ :each | 
							methods addAll: ((Pragma allNamed: pragma keyword in: each) collect: #method) ].
						methods ];
					format: #selector ].
			t transmit
				toOutsidePort: #selection;
				from: #methods port: #selection
		];
		startOn: self! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/30/2013 22:15'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	^ composite smalltalkCode 
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self getSource ];
		act: [ self browse ] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'! !

!CompiledMethod methodsFor: '*GT-InspectorExtensions-Core' stamp: 'MarcusDenker 3/11/2015 17:15'!
gtInspectorVariableValuePairs
	| literalIndex values |
	literalIndex := 0.
	values := OrderedCollection new.
	values addAll: (self literals collect: [ :aLiteral | 'literal', ( literalIndex := literalIndex + 1 ) asString -> aLiteral ]).
	self initialPC to: self size do: [ :index |
		values add:  ('bc ', index asString) ->  (self at: index)].
	^values.
	
! !

!Character class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:04'!
gtExampleA
	<gtExample>
	^ $A! !

!Character class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:04'!
gtExampleSpace
	<gtExample>
	^ self space! !

!Character methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/3/2014 14:59'!
gtInspectorCharacterIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Character';
		display: [
			{'self' -> self.
			'codepoint' -> self codePoint.
			'unicode' -> (String streamContents: [ :stream | 
				stream << 'U+'.
				self codePoint printOn: stream base: 16 nDigits: 4 ])} ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: [ :each | each value printString ];
		send: #value! !

!IRSequence class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 17:38'!
gtExampleSequence
	<gtExample>
	^ (self class >> #gtExampleSequence) ast ir startSequence! !

!MessageTally class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleSimplePrintString
	<gtExample>
	<label: 'Simple printString'>
	
	^ MessageTally new 
		spyEvery: 1 on: [10 timesRepeat: [1.23 printString]];
		yourself! !

!MessageTally class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 5/26/2014 07:57'!
on: aBlock
	"This utility method constructs a tally object and returns it without
	triggering the construction of the default report"
	^ MessageTally new
		spyEvery: 1
		on: aBlock;
		yourself ! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
children
	^ self sonsOver: 0! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 22:28'!
gtDisplayIdentifierOn: aStream
	class gtDisplayOn: aStream.
	self method methodClass ~~ class 
		ifTrue: [ aStream nextPut: $(; print: self method methodClass; nextPut: $) ].
	aStream 
		nextPutAll: '>>';
		store: self method selector! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 22:29'!
gtDisplayOn: aStream
	self gtDisplayIdentifierOn: aStream.
	aStream 
		nextPutAll: ' (';
		nextPutAll: self tally printString;
		nextPutAll: ')'! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:10'!
gtInspectorReportIn: composite
	<gtInspectorPresentationOrder: 60>
	^ composite text
		title: 'Report';
		display: [ String streamContents: [:s | self report: s ] ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/4/2014 22:56'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 50>
	^ self method ifNotNil: [
		self method gtInspectorSourceIn: composite]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
localTally
	^ self children 
		inject: self tally
		into: [ :diff :each | diff - each tally ]! !

!MessageTally methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/18/2014 14:05'!
localTime
	^ self children
		inject: self time 
		into: [ :diff :each | diff - each time ]! !

!OCAbstractScope class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:24'!
gtExampleMethodScope
	<gtExample>
	<label: 'Method scope'>
	
	^ (self class >> #gtExampleMethodScope) ast scope! !

!Number class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:23'!
gtExampleFourtyTwo
	<gtExample>
	<label: '42'>
	
	^ 42! !

!ByteArray class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtExampleSimple
	<gtExample>
	^ #[2r1010 8r333 16rFF]! !

!ByteArray methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/6/2014 06:48'!
gtInspectorBytesIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Bytes';
		display: [ 
			(self size < 2048 or: [ self confirm: 'Looking at more than 2048 bytes might be slow. Continue ?' ])
				ifTrue: [ {
					'hex string' -> (String streamContents: [ :out | 
						self do: [ :each | 
							each printOn: out base: 16 nDigits: 2 ] ]).
					'hex lines' -> (String streamContents: [ :out |
						self withIndexDo: [ :each :index |
							index = 1 ifFalse: [ 
								index - 1 \\ 8 = 0 ifTrue: [ out cr ] ifFalse: [ out space ] ].
								each printOn: out base: 16 nDigits: 2 ] ]).
					'latin1' -> ([ ZnByteEncoder latin1 decodeBytes: self ]
											on: ZnCharacterEncodingError do: [ :exception | exception ]).
					'utf8' -> ([ ZnUTF8Encoder new decodeBytes: self ] 
											on: ZnCharacterEncodingError do: [ :exception | exception ]).
					'integer' -> self asInteger.
					'integer reversed' -> self reversed asInteger } ]
				ifFalse: [ #() ] ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!GeneralScrollPane class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtScrollerWithWrappingAndNoSpaceFilling
	"
	self gtScrollerWithWrappingAndNoSpaceFilling openInWindow
	"

	<gtExample>
	| scrollpane pane |
	scrollpane := GeneralScrollPane new.
	scrollpane changeScrollerTableLayout.
	pane := PanelMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself.
	scrollpane scrollTarget: pane.
	Object methods
		do: [ :each | 
			| methodLabel |
			methodLabel := each selector asTextMorph lock 
				backgroundColor: Color lightBlue.
				
			pane addMorph: methodLabel ].
	scrollpane
		hResizing: #shrinkWrap;
		height: 400.
	^ scrollpane! !

!GeneralScrollPane class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtScrollerWithWrappingAndSpaceFilling
	"
	self gtScrollerWithWrappingAndSpaceFilling openInWindow
	"

	<gtExample>
	| scrollpane pane |
	scrollpane := GeneralScrollPane new.
	scrollpane changeScrollerTableLayout.
	pane := PanelMorph new
		changeTableLayout;
		hResizing: #spaceFill;
		vResizing: #spaceFill;
		yourself.
	scrollpane scrollTarget: pane.
	Object methods
		do: [ :each | 
			| methodLabel |
			methodLabel := Morph new
				changeTableLayout;
				wrapCentering: #center;
				hResizing: #spaceFill;
				vResizing: #spaceFill;
				color: Color lightBlue.
			methodLabel addMorphBack: (each selector asTextMorph lock).
				
			pane addMorph: methodLabel ].
	scrollpane
		hResizing: #shrinkWrap;
		height: 400.
	^ scrollpane! !

!FileSystem class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:15'!
gtExampleZip
	<gtExample>
	<label: 'Zip file system'>
	
	| zipFile zip |
	zipFile := FileSystem memory workingDirectory / 'test.zip'.
	zip := (FileSystem zip: zipFile) open.
	zip / 'sample.txt'
		writeStreamDo: [ :stream |
				stream nextPutAll: self comment ];
			yourself.
	^ zip! !

!FileSystem methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorRootItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	(self root gtInspectorItemsIn: composite)
		title: 'Root directory'! !

!FileSystem methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/7/2014 05:36'!
gtInspectorWorkingDirectoryItemsIn: composite
	<gtInspectorPresentationOrder: 40>
	(self workingDirectory gtInspectorItemsIn: composite)
		title: 'Working directory'! !

!NewValueHolder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/5/2014 21:46'!
gtAnnouncer
	^ announcer! !

!NewValueHolder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/18/2014 23:27'!
gtInspectorPresentationsIn: composite inContext: aGTInspector
	composite 
		updateOn: Announcement from: announcer.
	super gtInspectorPresentationsIn: composite inContext: aGTInspector! !

!SmalltalkImage class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/6/2015 12:40'!
gtExampleCurrent
	<gtExample>
	^ self current! !

!SmalltalkImage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/6/2015 12:39'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 0>
	composite table
		title: 'Details';
		display: [ 
			{ 
				'Image directory' -> self imageDirectory asFileReference.
				'Image format version' -> self imageFormatVersion.
				'License' -> self licenseString.
				'VM directory' -> self vmDirectory asFileReference.
				'VM version' -> self version
			} ];
		column: 'Property' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!RBMessageNode class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:00'!
gtExampleAddition
	<gtExample>
	^ RBMessageNode 
				receiver: (RBVariableNode named: 'self')
				selector: #+
				arguments: (Array with: (RBLiteralNode value: 0))! !

!VirtualMachine class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/6/2015 12:30'!
gtExampleBasic
	<gtExample>
	^ self new! !

!VirtualMachine methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/6/2015 12:34'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 0>
	composite table
		title: 'Details';
		display: [ 
			{ 
				'VM directory' -> self vmDirectory asFileReference.
				'VM build date' -> self buildDate.
				'VM version' -> self version.
				'Image directory' -> self imagePath asFileReference parent.
				'Image version' -> self imageVersionNumber.

			} ];
		column: 'Property' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!FLHeader methodsFor: '*GT-InspectorExtensions-Core' stamp: 'MaxLeske 3/4/2014 11:55'!
gtGetMetaData
	|assoc|
	
	assoc := OrderedCollection new.
	assoc add: ('Meta' ->(String streamContents: [ :stream |
		additionalObjects do: [ :add | add printOn: stream. stream crlf ]])).
	assoc add: ('Pre materialization actions:' -> (String streamContents: [ :stream |
		preMaterializationActions do: [ :action | action printOn: stream ]])).
	assoc add: ('Post materialization actions: ' -> (String streamContents: [ :stream |
		postMaterializationActions do: [ :action | action printOn: stream ]])).
	^ assoc! !

!GLMPresentation class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:02'!
gtExampleBasic
	<gtExample>
	^ self new! !

!GLMPresentation methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/4/2014 08:07'!
gtInspectorPanePortsIn: composite
	<gtInspectorPresentationOrder: 50>
	(self pane gtInspectorPortsIn: composite)
		title: 'Pane ports'! !

!SettingTree methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 3/12/2015 09:23'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 0>
	composite tree 
		title: 'Tree';
		display: [ self settingTreeRoots ];
		children: [ :each | self childrenOf: each ];
		format: [ :each | each settingDeclaration label ] ! !

!UndefinedObject methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 16:04'!
gtInspectorSourceCodeIn: composite
	" nothing to do "! !

!ZnResponse class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetEmpty
	<gtExample>
	<label: 'Response: Bad request <>'>
	
	^ self badRequest: ZnRequest gtExampleGetEmpty! !

!ZnResponse class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetLocalhost8080
	<gtExample>
	<label: 'Response: Not Found http://localhost:8080'>
	
	^ self notFound: 'http://localhost:8080'! !

!ZnResponse class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetPharo
	<gtExample>
	<label: ' Response: Created http://pharo.org'>
	
	^ self created: 'http://pharo.org'! !

!ZnResponse class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetRoot
	<gtExample>
	<label: 'Response: Redirect /'>
	
	^ self redirect: '/'! !

!ZnResponse methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 15:18'!
gtInspectorResponseIn: composite
	<gtInspectorPresentationOrder: 25>
	(self statusLine gtInspectorTextIn: composite)
		title: 'Response'! !

!String class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtInspectorFourtyTwo
	<gtExample>
	^ '42'! !

!String methodsFor: '*GT-InspectorExtensions-Core' stamp: 'JurajKubelka 3/28/2015 18:03'!
gtDisplayOn: aStream
	self printOn: aStream.! !

!String methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/9/2015 23:03'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: -10>  
	 composite rubricText
		title: 'String';
		display: [ self truncateWithElipsisTo: 10000 ]! !

!Integer class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:00'!
gtExample42
	<gtExample>
	^ 42! !

!Integer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/3/2014 14:45'!
gtInspectorIntegerIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Integer';
		display: [ | associations |
			associations :=	{
					'decimal' -> self printString.
					'hex' -> self printStringHex.
					'octal' -> (self printStringBase: 8).
					'binary' -> (self printStringBase: 2)} asOrderedCollection.
			(self between: 0 and: 16r10FFFF)
				ifTrue: [ associations add: 'character' -> self asCharacter ].
			associations ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: [ :each | each value printString ];
		send: #value! !

!BlockClosure class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:08'!
gtExampleEmpty
	<gtExample>
	<label: 'Empty'>
	
	^ [  ]! !

!BlockClosure class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:08'!
gtExampleOneArgument
	<gtExample>
	<label: 'With one argument'>
	
	^ [ :x | x ]! !

!BlockClosure class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:08'!
gtExampleTwoArguments
	<gtExample>
	<label: 'With two arguments'>
	
	^ [ :x :y | x + y ]! !

!BlockClosure methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/23/2014 15:32'!
gtInspectorSourceCodeIn: composite 
	<gtInspectorPresentationOrder: 40>
	self sourceNode gtInspectorSourceCodeIn: composite! !

!ThemeIcons methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 3/6/2015 10:41'!
gtInspectorIconsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Icons';
		display: [ 
			self iconSelectors asSortedCollection 
				collect: [ :each | each -> (self perform: each) ] ];
		icon: [ :each | each value ];
		format: [ :each | each key ]! !

!KMDispatcher class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:18'!
gtExampleDispatcherWithTarget
	<gtExample>
	<label: 'Dispatcher with target'>
	
	^ self target: Morph new! !

!KMDispatcher class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:18'!
gtExampleDispatcherWithTargetAndShortcuts
	<gtExample>
	<label: 'Dispatcher with target and shortcuts'>
	
	^ BorderedMorph new kmDispatcher! !

!KMDispatcher class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleEmptyDispatcher
	<gtExample>
	<label: 'Empty dispatcher'>
	
	^ self new! !

!KMDispatcher methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/27/2015 20:59'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Keys';
		display: [ 
			((self targets collect: #category)
				add: self directKeymaps;
				yourself)
				flatCollect: [ :category | 
					category allEntries keymaps collect: [ :key | key -> category ] ]
				 ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!GlobalVariable class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:00'!
gtExampleSmalltalk
	<gtExample>
	^ Smalltalk globals associations detect: [:assoc | assoc key = #Smalltalk ]! !

!Collection class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:04'!
gtExampleEmptyArray
	<gtExample>
	^ #()! !

!Collection class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:04'!
gtExampleOrderedCollectionWithOneElement
	<gtExample>
	^ #(42) asOrderedCollection! !

!Collection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'VincentBlondeau 6/12/2015 23:11'!
gtDisplayOn: s
	self printNameOn: s.
	s
		space;
		nextPut: $[;
		nextPutAll: self size asString;
		nextPutAll:
				(self size = 1
						ifTrue: [ ' item' ]
						ifFalse: [ ' items' ]);
		nextPut: $];
		space.
		self printElementsOn: s.
	! !

!Collection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:51'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 0>  
	^ (composite list)
		title: 'Items';
		display: [ :aCollection | self ];
		beMultiple;
		withSmalltalkSearch;		
		format: [ :each | GTObjectPrinter new asTruncatedTextFrom: each ];
		send: [ :result | result isNil 
			ifTrue:[nil]
			ifFalse:[ (result size = 1) 
				ifTrue: [result anyOne] 
				ifFalse: [self species withAll: result]]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!Pragma class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:24'!
gtExamplePragma
	<gtExample>
	<label: 'Pragma'>
	
	^ (Pragma class >> #gtExamplePragma) pragmas anyOne! !

!Pragma class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/4/2013 22:16'!
gtInspectorAnnotatedMethodsIn: composite
	<gtInspectorPresentationOrder: 30> 
	composite table 
		title: 'All';
		showOnly: 50;
		withSmalltalkSearch;
		display: [:anObject | 
			| pragmas |
			pragmas := OrderedCollection new.
			Object withAllSubclassesDo: [:each |
				Pragma withPragmasIn: each do: [:p |
					pragmas add: p]].
			(pragmas groupedBy: #keyword) associations sorted: [ :a :b | 
				a key < b key ]
		];
		column: 'Keyword' evaluated: [ :each | each key ];
		column: 'Instances' evaluated: [ :each | each value size asString ];
		send: #value! !

!Pragma methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/7/2014 16:14'!
gtDisplayOn: stream
	self method gtDisplayOn: stream.
	stream space.
	self printOn: stream! !

!Pragma methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/6/2013 22:09'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!CollectionValueHolder methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 8/21/2014 17:37'!
addAnnouncementFirst: ann

	^ self addFirst: (DateAndTime now -> ann)! !

!MethodModified class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:20'!
gtExampleMethodModified
	" this is a fake annoucement, we just pick 2 arbitrary methods "
	<gtExample>
	<label: 'Diff old and new method'>
	
	^ MethodModified new 
		oldMethod: (MethodModified >> #gtMethodDiffIn:);
		method: (MethodModified class >> #gtExampleMethodModified);
		yourself! !

!MethodModified methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 8/21/2014 19:43'!
gtMethodDiffIn: aComposite
	<gtInspectorPresentationOrder: 40>
	aComposite diff
		title: 'Diff';
		display: [ 
			Array 
				with: self newMethod sourceCode
				with: self oldMethod sourceCode ]
! !

!MetacelloProjectReferenceSpec class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleProjectReferenceSpec
	<gtExample>
	<label: 'Metacello project reference'>
	
	^ (ConfigurationOfGTInspectorCore project version: #development) projects anyOne! !

!MetacelloProjectReferenceSpec methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/11/2014 06:49'!
gtInspectorProjectsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list 
		title: 'Projects';
		display: [
			| projects |
			projects := OrderedCollection new.
			self
					projectDo: [:prj | projects add: prj ] 
					packageDo: [:pkg | ] 
					groupDo: [:ignored | ].
			projects ]
! !

!RGMethodDefinition class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleMethod
	<gtExample>
	<label: 'RMethodDefinition'>
	
	^ (GTInspector class >> #gtInspectorExtensionsIn:) asRingDefinition! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/1/2014 23:50'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 4>
	composite list 
		title: 'Implementors';
		display: [ self compiledMethod implementors ]! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/1/2014 23:50'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 2>
	composite list 
		title: 'Senders';
		display: [ self compiledMethod senders ]! !

!RGMethodDefinition methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/1/2014 23:49'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 00>
	^ composite smalltalkCode 
		title: 'Source';
		smalltalkClass: [ self methodClass ];
		display: [ self sourceCode ];
		act: [ :text | self methodClass compile: text text notifying: nil ]
			icon: GLMUIThemeExtraIcons glamorousAccept
			on: $s
			entitled: 'Accept';
		act: [ self browse ] 
			icon: GLMUIThemeExtraIcons glamorousBrowse 
			entitled: 'Browse'! !

!ReadStream class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleReadStream
	<gtExample>
	<label: 'Stream'>
	
	^ 'GTInspector' readStream! !

!ReadStream class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleReadStreamAtEnd
	<gtExample>
	<label: 'Stream at end'>
	
	^ 'GTInspector' readStream 
		upToEnd;
		yourself! !

!ReadStream class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleReadStreamEmpty
	<gtExample>
	<label: 'Empty stream'>
	
	^ '' readStream! !

!ReadStream class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleReadStreamWithPosition
	<gtExample>
	<label: 'Stream with position'>
	
	^ 'GTInspector' readStream 
		next; 
		next; 
		yourself! !

!ReadStream methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 13:00'!
gtInspectorStreamStateIn: composite
	<gtInspectorPresentationOrder: 50>
	(composite wrapper with: [ :w | 
		w title: 'Contents'.
		w show: [ :a | 
			a text
				display: [ self contents ];
				initialize: [ :aPresentation | 
					aPresentation selectionInterval: (1 to: self position) ] ] ])
		startOn: self! !

!WindowModel methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/2/2013 16:31'!
gtInspectorModelNestingIn: composite
	self model gtInspectorModelNestingIn: composite! !

!LiteralVariable class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 17:20'!
gtExampleUniqueLiteralVariable
	<gtExample>
	^ self named: #thisLiteralVariableNameIsProbablyNotTakenYet! !

!GLMTransmission methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/29/2014 11:07'!
gtDisplayOn: stream
	self origins asArray gtDisplayOn: stream.
	stream nextPutAll: '->'.
	self destination gtDisplayOn: stream! !

!SequenceableCollection methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/19/2015 10:51'!
gtInspectorItemsIn: composite
	^ composite table
		title: 'Items';
		display: [ :aCollection | [(1 to: self size) collect: [ :index | index -> (self at: index) ]] on:Error do:[#()]];
		beMultiple;
		searchOn: [:text :each | 
			Smalltalk compiler evaluate: ' | entity each | each := self. entity := each.', text for: each value logged: false];
		column: 'Index' evaluated: [ :assoc | assoc key asString ];
		column: 'Item' evaluated: [ :assoc | GTObjectPrinter new asTruncatedTextFrom: assoc value ];
		send: [ :result | 
			result isNil
				ifTrue: [ nil ]
				ifFalse: [ result value size = 1 
					ifTrue: [result anyOne value]  
					ifFalse: [self species withAll: (result collect: [:each | each value])]]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'.! !

!Symbol class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:03'!
gtExampleFourtyTwo
	<gtExample>
	^ #fourtyTwo! !

!Symbol methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/19/2013 06:01'!
gtInspectorImplementorsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Implementors';
		display: [ self systemNavigation allImplementorsOf: self ];
		when: [ (self systemNavigation allImplementorsOf: self) notEmpty ];
		showOnly: 30! !

!Symbol methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/17/2014 23:10'!
gtInspectorSendersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 
		title: 'Senders';
		display: [ self systemNavigation allSendersOf: self ];
		when: [ (self systemNavigation allSendersOf: self) notEmpty ];
		showOnly: 30;
		withSmalltalkSearch ! !

!IRInstruction class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 18:33'!
gtExamplePushReciever
	<gtExample>
	^ (self class >> #gtExamplePushReciever) ast ir startSequence sequence first! !

!RBMethod class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleThisMethod
	<gtExample>
	<label: 'This method'>
	
	^ RBMethod class>>#gtExampleThisMethod! !

!Text class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleSimple
	<gtExample>
	<label: 'Simple'>
	
	^ 'fourtytwo' asText! !

!Text methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/21/2013 22:45'!
gtInspectorItemsIn: composite
	"No items presentation for a Text"! !

!Text methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/13/2014 23:30'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: -10>  
	 composite text
		title: 'Text';
		format: self! !

!FileReference class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtExampleDirectory
	<gtExample>
	| directory subDirectory |
	directory := FileSystem memory workingDirectory / 'directory'.
	directory createDirectory.
	directory / 'file1.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File1 contents' ].
	directory / 'file2.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File2 contents' ].
	subDirectory := (directory / 'subdirectory') createDirectory.
	subDirectory / 'file3.txt' writeStreamDo: [ :stream | stream nextPutAll: 'File3 contents' ].
	^ directory! !

!FileReference class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtExampleGif
	<gtExample>
	^ FileSystem memory workingDirectory / 'pharoicon.gif' 
		writeStreamDo: [ :stream |
			GIFReadWriter 
				putForm: ThemeIcons current pharoIcon 
				onStream: stream ];
		yourself! !

!FileReference class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtExamplePng
	<gtExample>
	^ FileSystem memory workingDirectory / 'pharoicon.png' 
		writeStreamDo: [ :stream |
			PNGReadWriter 
				putForm: ThemeIcons current pharoIcon 
				onStream: stream ];
		yourself! !

!FileReference class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:04'!
gtExampleText
	<gtExample>
	^ FileSystem memory workingDirectory / 'sample.txt' 
		writeStreamDo: [ :stream |
			stream nextPutAll: self comment ];
		yourself! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/6/2014 13:18'!
gtDisplayOn: stream
	filesystem printPath: path on: stream! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/28/2014 06:40'!
gtInspectorActionMaterializeFuel
	<gtInspectorAction>
	^ GLMGenericAction new
		action: [ :composite | 
			| result |
			result := FLMaterializer materializeFromFileNamed: self fullName.
			composite selection: result ];
		icon: GLMUIThemeExtraIcons glamorousAdd;
		condition: [ self extension = 'fuel' ];
		title: 'Materialize'! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/24/2014 15:00'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 5>
	composite rubricText
			title: 'Contents';
			display: [ 
				self readStreamDo: [ :stream | 
					| result |
					result := [(stream next: 10000) asString]
						on: Error 
						do: [ (stream binary next: 10000) asString ].
					stream size > 10000
						ifTrue: [ result, '  ... truncated ...' ]
						ifFalse: [ result ] ] ];
			withLineNumbers: true;
			when: [ self isFile ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'MaxLeske 3/4/2014 11:57'!
gtInspectorFuelIn: composite
	<gtInspectorPresentationOrder: 40>
	"(FileSystem disk workingDirectory / 'GTtest.fuel') writeStreamDo: [ :stream |
	FLSerializer newDefault
		at: #author putAdditionalObject: 'Author: Max Leske';
		at: #date putAdditionalObject: DateAndTime now;
		addPreMaterializationAction: [ Smalltalk inform: 'starting materialization' ];
		addPostMaterializationAction: [ :materialization | materialization inspect ];
		serialize: 'foo' on: stream binary ].
	
FLMaterializer materializeFromFileNamed: 'GTtest.fuel'"
	composite table
			title: 'Fuel Header';
			display: [
				(FLMaterializer materializeHeaderFromFileNamed: self fullName) gtGetMetaData ];
			column: 'Property' evaluated: [:assoc| assoc key ];
			column: 'Value' evaluated: [:assoc| assoc value];
			when: [ self extension = 'fuel' ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/22/2014 11:37'!
gtInspectorGifIn: composite
	<gtInspectorPresentationOrder: 0>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | GIFReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imageGif ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/22/2014 11:37'!
gtInspectorItemsIn: composite
	<gtInspectorPresentationOrder: 0>
	^ composite table 
		title: 'Items';
		display: [ 
			| children |
			children := self directories, self files.
			self isRoot 
				ifTrue: [ children ]
				ifFalse: [ 
					children asOrderedCollection 
						addFirst: self parent;
						yourself ] ];
		column: 'Name' evaluated: [:each | (self isChildOf: each) 
								ifTrue: [ '..' ] 
								ifFalse: [ each basename ]] width: 400;
		column: 'Size' evaluated: [:each | each humanReadableSize] width: 100;
		column: 'Creation' evaluated: [ :each | 
			String streamContents: [:s | 
				each creationTime printYMDOn: s.
				s nextPut: Character space.
				each creationTime printHMSOn: s ]];
		icon: [ :each | 
			each isDirectory 
				ifTrue: [ GLMUIThemeExtraIcons glamorousFolder ] 
				ifFalse: [ GLMUIThemeExtraIcons glamorousBrowse ] ];
		when: [self isDirectory and: [self hasChildren]];
		selectionAct: [:table | table selection delete. table update] entitled: 'Delete';
		act: [ :table | table update ] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Refresh'! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/27/2014 10:44'!
gtInspectorJpegIn: composite
	<gtInspectorPresentationOrder: 0>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | ImageReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imageJpeg ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 10/22/2014 11:37'!
gtInspectorPngIn: composite
	<gtInspectorPresentationOrder: 0>
	composite morph
			title: 'Picture';
			display: [ self binaryReadStreamDo: [ :stream | PNGReadWriter formFromStream: stream ] ];
			when: [ self mimeTypes notNil and: [ self mimeTypes first matches: ZnMimeType imagePng ] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 9/8/2015 15:02'!
gtInspectorStScriptIn: composite
	<gtInspectorPresentationOrder: 0>
	composite pharoPlayground
			title: 'Script';
			display: [ self readStreamDo: [ :s | s contents ] ];
			act: [ :text |
					text selectionInterval: (1 to: text text size).
					text highlightEvaluateAndDo: [ :result | text selection: result ] ]
				icon: GLMUIThemeExtraIcons glamorousGo
				on: $G
				entitled: 'Do it all and go';
			installDefaultSelectionActions;
			act: [ :text |
				self ensureDelete; writeStreamDo: [ :s | s nextPutAll: text text asString ] ]
				icon: GLMUIThemeExtraIcons glamorousSave
				on: $s
				entitled: 'Save';
			when: [ self extension = 'st' or: [self extension = 'ph'] ]! !

!FileReference methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/3/2015 12:45'!
gtInspectorZipItemsIn: composite
	<gtInspectorPresentationOrder: 0>
	^ composite table 
		title: 'Items';
		display: [ 
			| children root |
			root := (FileSystem zip: self) open workingDirectory.
			children := root directories, root files.
			self isRoot 
				ifTrue: [ children ]
				ifFalse: [ 
					children asOrderedCollection 
						addFirst: self parent;
						yourself ] ];
		column: 'Name' evaluated: [:each | self parent = each 
								ifTrue: [ '..' ] 
								ifFalse: [ each basename ]] width: 400;
		column: 'Size' evaluated: [:each | each humanReadableSize] width: 100;
		column: 'Creation' evaluated: [ :each | 
			String streamContents: [:s | 
				each creationTime printYMDOn: s.
				s nextPut: Character space.
				each creationTime printHMSOn: s ]];
		icon: [ :each | 
			each isDirectory 
				ifTrue: [ GLMUIThemeExtraIcons glamorousFolder ] 
				ifFalse: [ GLMUIThemeExtraIcons glamorousBrowse ] ];
		when: [ self isFile and: [ #('zip' 'jar' 'ear' 'war') includes: self extension ] ];
		act: [ :table | table update ] icon: GLMUIThemeExtraIcons glamorousRefresh entitled: 'Refresh'! !

!Announcer class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:08'!
gtExampleEmptyAnnouncer
	<gtExample>
	<label: 'Empty Announcer'>
	
	^ self new! !

!Announcer class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:08'!
gtExampleSystemAnnouncer
	<gtExample>
	<label: 'System Announcer'>
	
	^ SystemAnnouncer uniqueInstance! !

!Announcer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/27/2014 10:17'!
gtInspectorAnnouncementsIn: composite context: aGTContext
	<gtInspectorPresentationOrder: 40>
	| recordedAnnouncements messageSend |
	
	recordedAnnouncements := CollectionValueHolder value: OrderedCollection new.
	messageSend := MessageSend receiver: recordedAnnouncements selector: #addAnnouncementFirst:.
	self
		when: Announcement
		send: #cull:
		to: messageSend.
	aGTContext when: GLMBrowserClosing do: [ self unsubscribe: messageSend ].
	composite table
		title: 'Announcements';
		display: [ recordedAnnouncements value ];
		column: 'Time' evaluated: #key;
		column: 'Announcement' evaluated: #value;
		send: #value;
		showOnly: 50;
		format: #gtDisplayString;
		filterOn: [:text :each | Smalltalk compiler evaluate: '| date each | date := self key. each := self value. ', text for: each logged: false ];
		updateOn: Announcement from: recordedAnnouncements gtAnnouncer;
		act: [ :table | 
			recordedAnnouncements := OrderedCollection new.
			table update ] 
			icon: GLMUIThemeExtraIcons glamorousCancel 
			entitled: 'Reset'! !

!Announcer methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 6/8/2014 23:34'!
gtInspectorSubscriptionsIn: composite
	<gtInspectorPresentationOrder: 30>
	composite table
		title: 'Subscriptions';
		display: [ self subscriptions glmSubscriptions ];
		when: [ self numberOfSubscriptions isZero not ];
		column: 'Subscriber' evaluated: [ :each | each subscriber asString ];
		column: 'Announcement' evaluated: [ :each | each announcementClass name ];
		column: 'Kind' evaluated: [ :each | each class name ];
		act: [ :table | 
			self subscriptions reset.
			table update ] icon: GLMUIThemeExtraIcons glamorousCancel entitled: 'Reset';
		selectionAct: [ :table | 
			self subscriptions remove: table selection.
			table update ] entitled: 'Remove subscription'! !

!RPackage class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleEmpty
	<gtExample>
	<label: 'Empty package'>
	
	^ self named: 'Empty'! !

!RPackage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/6/2014 14:21'!
gtInspectorDefinedClassesIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list
		title: 'Classes';
		display: #classes;
		format: #gtDisplayString;
		tags: [ :each | each category ]! !

!RPackage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/6/2014 14:21'!
gtInspectorTagsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Tags';
		display: #classTags;
		format: #gtDisplayString;
		when: [ self classTags notEmpty ]! !

!ZnMessage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 15:09'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 40>
	self hasEntity
		ifTrue: [ 
			self contentType isBinary
				ifTrue: [ 
					composite table
						title: 'Contents';
						display: [ {'entity' -> self entity} ];
						column: 'Key' evaluated: #key;
						column: 'Value' evaluated: #value;
						send: #value ]
				ifFalse: [ 
					composite rubricText
						title: 'Contents';
						format: self contents ] ]! !

!ZnMessage methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 14:14'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers gtInspectorHeadersIn: composite) 
		title: [:anObject | self headers headers size asString , ' headers' ]! !

!ReflectiveMethod class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 17:16'!
gtExampleMethod
	<gtExample>
	^ self on: (self class >> #gtExampleMethod)! !

!Float class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:23'!
gtExampleE
	<gtExample>
	<label: 'Float with e'>
	
	^ 42.42e42! !

!Float class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:24'!
gtExampleNegativeE
	<gtExample>
	<label: 'Float with negative e'>
	
	^ 42.42e-42! !

!Float class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:24'!
gtExampleZero
	<gtExample>
	<label: 'Zero'>
	
	^ 0.0! !

!Float methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 12/1/2014 21:52'!
gtInspectorFloatIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Float';
		display: [ 
			(self respondsTo: #binaryLiteralString)
				ifTrue: [
					{'binary' -> self binaryLiteralString.
					'significand' -> self significand.
					'exponent' -> self exponent} ]
				ifFalse: [
					{'significand' -> self significand.
					'exponent' -> self exponent} ] ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!Float methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TommasoDalSasso 1/30/2015 16:42'!
gtInspectorVariableValuePairs
	
	^ OrderedCollection
		with: '1' -> (self at: 1)
		with: '2' -> (self at: 2)! !

!GTExample class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 18:27'!
gtExampleBasic
	<todo: 'fix: corrupt image state if this is an example itself'>
	"<gtExample>"
	^ self new
		initializeFromFinder: (GTExampleFinder new
										source: self;
										provider: self;
										subjects: nil;
										yourself) 
			withPragma: ((GTExample class >> #gtExampleBasic) pragmas 
										detect: [ :each | each isGTExamplePragma ]);
		yourself! !

!MCPackageManager class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 4/21/2014 13:09'!
gtInspectorManagersIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Managers';
		display: [ self allManagers sorted: [ :x :y | x packageName < y packageName ] ];
		format: #packageName;
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ]! !

!MCPackageManager methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/4/2014 21:53'!
gtDisplayOn: stream
	stream nextPutAll: self package name! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/12/2014 22:31'!
gtInspectorAllReferencesIn: composite
	"This provides a list of all methods provided by the current class"
	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'All Ref';
		display: [ (SystemNavigation default allReferencesTo: self binding) 
						sorted: [ :x :y | x name < y name ] ];
		format: #name;
		tags: [ :each | { each package name } ]! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/12/2014 22:32'!
gtInspectorAllReferencesOutsideIn: composite
	"This provides a list of all methods provided by the current class"
	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'All Ref Outside';
		display: [ ((SystemNavigation default allReferencesTo: self binding) 
							reject: [ :method | method package name == self package name ])
						sorted: [ :x :y | x name < y name ] ];
		format: #name;
		tags: [ :each | { each package name } ]! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 12/26/2014 14:11'!
gtInspectorCommentIn: composite
	"This provides an editable comment of the current class"
	<gtInspectorPresentationOrder: 20>
	composite text 
		title: 'Comment';
		display: [ self comment ];
		act: [ :text | 
			self comment: text text stamp: Author changeStamp]
			icon: GLMUIThemeExtraIcons glamorousAccept 
			on: $s
			entitled: 'Accept'! !

!TClass methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 10/12/2014 22:30'!
gtInspectorMethodsIn: composite
	"This provides a list of all methods provided by the current class"
	<gtInspectorPresentationOrder: 20>
	composite list 
		title: 'Methods';
		display: [ (self allMethods collect: #asRingDefinition) 
						sorted: [ :x :y | x selector < y selector ] ];
		format: #selector;
		tags: [ :each | {each methodClass name} ]! !

!Color class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:03'!
gtExampleColorRed
	<gtExample>
	
	^ Color red! !

!Color methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/18/2013 11:46'!
gtInspectorColorIn: composite
	<gtInspectorPresentationOrder: 30>
	composite morph 
		title: 'Color';
		display: [ BorderedMorph new color: self ]! !

!GLMCompositePresentation methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 05:46'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ (composite wrapper with: [ :w |
		w title: 'Live'.
		w show: [:a | a custom: self copy ] ]
		) startOn: self entity! !

GLMCompositePresentation subclass: #GTSimpleRBTreeBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GT-InspectorExtensions-Core'!

!GTSimpleRBTreeBrowser commentStamp: '<historical>' prior: 0!
This is a simple browser that displays the rb tree and previews each node on the source code.

Example:
self openOn: (self>>#compose) parseTree!

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 12/21/2013 23:09'!
compose
	self title: 'Tree'.
	self tabulator with: [ :browser |
		browser
			row: #tree;
			row: #source.
		browser transmit
			to: #tree;
			andShow: [ :a | self treeIn: a ].
		browser transmit
			to: #source;
			andShow: [ :a | self sourceIn: a ].
		browser transmit
			from: #tree;
			to: #source port: #selectionInterval;
			transformed: [ :rbNode | rbNode sourceInterval ].
		browser transmit
			toOutsidePort: #selection;
			from: #tree port: #selectedNode ]! !

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 11/29/2013 14:56'!
sourceIn: a
	^ a smalltalkCode 
		smalltalkClass: [ :each | each parents first methodClass ]; 
		display: [ :each | each source ]! !

!GTSimpleRBTreeBrowser methodsFor: 'building' stamp: 'TudorGirba 8/23/2011 01:17'!
treeIn: a
	^ a tree
		rootsExpanded;
		display: [ :anObject | {anObject} ];
		children: [ :each | each children ];
		selectionPopulate: #selectedNode
			on: $o
			entitled: 'Open'
			with: [ :tree | tree selection ];
		format: [ :each | 
					String
						streamContents: [ :stream | 
							stream
								nextPutAll: each class name;
								nextPut: $(;
								nextPutAll: ((each formattedCode truncateTo: 50) copyReplaceAll: String cr with: String space);
								nextPut: $) ] ]! !

!MetacelloSpec class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleMetacelloSpec
	<gtExample>
	<label: 'Metacello group reference'>
	
	^ (ConfigurationOfGTInspectorCore project version: #development) groups anyOne! !

!MetacelloSpec methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/12/2014 23:05'!
gtInspectorCodeIn: composite
	<gtInspectorPresentationOrder: 40>
	composite pharoPlayground 
		title: 'Code';
		display: [ 
			String streamContents: [ :s | self configMethodOn: s indent: 0] ]
! !

!TClassDescription methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/8/2015 16:31'!
gtInspectorUsersIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list 	
		title: 'Users';
		when: [ self isTrait ];
		display: [ 
			self traitUsers asArray
			"Smalltalk allClasses select: [ :class |
			   class traitComposition traits includes: self ]" ]! !

!Bitmap class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:08'!
gtExampleIconBits
	<gtExample>
	<label: 'Icon bits'>
	
	^ ThemeIcons current pharoIcon bits! !

!Bitmap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 8/22/2011 11:49'!
gtInspectorItemsIn: composite
	"No items presentation for a Bitmap"! !

!Array class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:03'!
gtExample
	<gtExample>
	^ #(42 42.0 #fourtytwo 'fourtytwo')! !

!RPackageTag methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/6/2014 14:16'!
gtInspectorDefinedClassesIn: composite
	<gtInspectorPresentationOrder: 30>
	composite list
		title: 'Classes';
		display: #classes;
		format: #gtDisplayString! !

!Time class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleNow
	<gtExample>
	<label: 'Now'>
	
	^ self now! !

!Time methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 20:12'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: [ 'Details' ];
		display: [ 
					{'hours' -> self hours.
					'minutes' -> self minutes.
					'seconds' -> self seconds.
					'nanoseconds' -> self nanoSecond.
					'meridian' -> self meridianAbbreviation.
					'iso' -> self print24 } ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!Context class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:14'!
gtExampleTthisContext
	<gtExample>
	<label: 'thisContext'>
	
	^ thisContext! !

!Context methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/6/2015 14:26'!
gtInspectorSourceIn: composite
	<gtInspectorPresentationOrder: 30> 
	self method gtInspectorSourceIn: composite! !

!Context methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TommasoDalSasso 1/30/2015 16:58'!
gtInspectorVariableValuePairs
	"We override the variables with context specific ones"
	| superVariableValuePairs tempVariableValuePairs tempIndex |
	tempIndex := 0. 
	superVariableValuePairs := super gtInspectorVariableValuePairs.
	tempVariableValuePairs := (self tempNames
						collect: [ :tempName ||value|
							tempIndex := tempIndex + 1.
							value := [self debuggerMap namedTempAt: tempIndex in: self] 
								on: Error 
								do: [value := (Text string: 'error obtaining field value' attribute: TextColor red) asString ].
							('[' , tempName , ']') -> value ]) sort asOrderedCollection.
		^ tempVariableValuePairs addAll: superVariableValuePairs; yourself! !

!Duration class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:03'!
gtExampleOneDay
	<gtExample>
	^ self days: 1! !

!Duration class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:03'!
gtExampleOneHour
	<gtExample>
	^ self hours: 1! !

!Duration class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:03'!
gtExampleOneMinute
	<gtExample>
	^ self minutes: 1! !

!Duration methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 20:35'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: [ 'Details' ];
		display: [ 
					{'days' -> self days.
					'hours' -> self hours.
					'minutes' -> self minutes.
					'seconds' -> self seconds .
					'nanoseconds' -> self nanoSeconds } ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!Form class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:16'!
gtExampleEmptyForm32x32
	<gtExample>
	<label: 'Empty Form 32x32'>
	
	^ Form extent: 32@32! !

!Form methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/14/2014 06:51'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 90>  
	^ composite morph 
		title: 'Morph';
		display: [ self asMorph ]! !

!ZnHeaders class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleDefaultRequestHeaders
	<gtExample>
	<label: 'Default request headers'>
	
	^ self defaultRequestHeaders! !

!ZnHeaders class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleDefaultResponseHeaders
	<gtExample>
	<label: 'Default response headers'>
	
	^ self defaultResponseHeaders! !

!ZnHeaders methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 14:08'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers gtInspectorItemsIn: composite) 
		display: [ :anObject | self headers associations ];
		title: [ :anObject | self headers size asString , ' items' ]! !

!GLMPane class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:03'!
gtExampleBasic
	<gtExample>
	^ self named: 'Basic'! !

!GLMPane methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/4/2014 08:06'!
gtInspectorPortsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: 'Ports';
		display: [ self ports ];
		column: 'Port' evaluated: [ :each | each name ];
		column: 'Value' evaluated: [ :each | each value asString ]! !

!Date class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:14'!
gtExampleToday
	<gtExample>
	<label: 'Today'>
	
	^ self today! !

!Date methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 20:04'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: [ 'Details' ];
		display: [ 
					{'year' -> self year.
					'month' -> self monthIndex.
					'month name' -> self monthName.
					'day of month' -> self dayOfMonth.
					'day of week' -> self dayOfWeekName.
					'day of year' -> self dayOfYear.
					'iso' -> self yyyymmdd } ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!Date methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 19:58'!
gtInspectorPreviewIn: composite
	<gtInspectorPresentationOrder: 30>
	composite morph
		title: 'Calendar';
		morph: [ CalendarMorph on: self ]! !

!MetacelloProject methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/14/2014 23:01'!
gtInspectorVersionsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Versions';
		display: #versions! !

!RBProgramNode class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:25'!
gtExampleRBProgramNode
	<gtExample>
	<label: 'RBProgramNode'>
	
	^ (GTInspector class >> #gtInspectorExtensionsIn:) parseTree! !

!RBProgramNode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/22/2015 18:46'!
gtInspectorSourceCodeIn: composite
	<gtInspectorPresentationOrder: 30> 

	^ composite smalltalkCode 
		title: 'Source code';
		display: [ self source ];
		smalltalkClass: [ 
			self parents first compilationContext ifNotNil: [ :ctx | ctx getClass ] ]; 
		initialize: [ :presentation | 
			presentation selectionInterval: self sourceInterval ];
		when: [ self source notNil ];
		act: [ self methodNode method compiledMethod browse ] icon: GLMUIThemeExtraIcons glamorousBrowse entitled: 'Browse'! !

!RBProgramNode methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 7/14/2014 10:29'!
gtInspectorTreeIn: composite
	<gtInspectorPresentationOrder: 30> 
	^ (GTSimpleRBTreeBrowser new treeIn: composite)
		title: 'Tree'! !

!ZnRequestLine class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetEmpty
	<gtExample>
	<label: 'Request line: GET <>'>
	
	^ self method: #GET uri: ''! !

!ZnRequestLine class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetLocalhost8080
	<gtExample>
	<label: 'Request line: GET http://localhost:8080'>
	
	^ self method: #GET uri: 'http://localhost:8080'! !

!ZnRequestLine class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetPharo
	<gtExample>
	<label: 'Request line: GET http://pharo.org'>
	
	^ self method: #GET uri: 'http://pharo.org'! !

!ZnRequestLine class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetRoot
	<gtExample>
	<label: 'Request line: GET /'>
	
	^ self method: #GET uri: '/'! !

!ZnRequestLine methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 15:19'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite rubricText
		title: 'HTTP';
		format: [ String streamContents: [ :out | self writeOn: out ] ]! !

!KMKeymap class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleKeymapA
	<gtExample>
	<label: 'Keymap: a'>
	
	^ self 
		named: #a 
		shortcut: $a asKeyCombination
		action: [ ]! !

!KMKeymap class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleKeymapFOO
	<gtExample>
	<label: 'Keymap: FOO'>
	
	^ self 
		named: #Foo
		shortcut: $F asKeyCombination, $O asKeyCombination, $O asKeyCombination
		action: [ ]! !

!KMKeymap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/10/2014 07:07'!
gtDisplayOn: aStream
	aStream 
		nextPutAll: self name gtDisplayString;
		nextPutAll: ' on ';
		nextPutAll: self shortcut gtDisplayString;
		nextPutAll: ' do ' ;
		nextPutAll: self action gtDisplayString! !

!KMKeymap methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/20/2014 22:11'!
gtInspectorSourceCodeIn: composite
	<gtInspectorPresentationOrder: 30> 

	^ self action gtInspectorSourceCodeIn: composite! !

!ZnMimePart class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleEmptyField
	<gtExample>
	<label: 'Empty field'>
	
	^ self fieldName: 'value' value: ''! !

!ZnMimePart class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleField
	<gtExample>
	<label: 'Field'>
	
	^ self fieldName: 'message' value: 'hello world'! !

!ZnMimePart class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleFile
	<gtExample>
	<label: 'File'>
	
	^ self 
		fieldName: 'file' 
		fileName: 'message.txt' 
		entity: (ZnEntity text: 'Hello World')! !

!ZnMimePart methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 15:15'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 40>
	self hasEntity
		ifTrue: [ 
			self contentType isBinary
				ifTrue: [ 
					composite table
						title: 'Contents';
						display: [ {'entity' -> self entity} ];
						column: 'Key' evaluated: #key;
						column: 'Value' evaluated: #value;
						send: #value ]
				ifFalse: [ 
					composite rubricText
						title: 'Contents';
						format: self contents ] ]! !

!ZnMimePart methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 14:17'!
gtInspectorHeadersIn: composite 
	<gtInspectorPresentationOrder: 30>
	^ (self headers gtInspectorHeadersIn: composite) 
		title: [:anObject | self headers headers size asString , ' headers' ]! !

!DateAndTime class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:14'!
gtExampleNow
	<gtExample>
	<label: 'Now'>
	
	^ self now! !

!DateAndTime methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/4/2014 20:19'!
gtInspectorDetailsIn: composite
	<gtInspectorPresentationOrder: 30>
	^ composite table
		title: [ 'Details' ];
		display: [ 
					{'year' -> self year.
					'month' -> self monthIndex.
					'month name' -> self monthName.
					'day of month' -> self dayOfMonth.
					'day of week' -> self dayOfWeekName.
					'day of year' -> self dayOfYear.
					'hours' -> self hours.
					'minutes' -> self minutes.
					'seconds' -> self seconds.
					'nanoseconds' -> self nanoSecond.
					'meridian' -> self meridianAbbreviation.
					'offset' -> self offset.
					'date' -> self asDate.
					'time' -> self asTime.
					'iso' -> self printString.
					'utc' -> self asUTC } ];
		column: 'Key' evaluated: #key;
		column: 'Value' evaluated: #value;
		send: #value! !

!Canvas class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:14'!
gtExampleNullCanvas
	<gtExample>
	<label: 'Canvas: Null'>
	
	^ NullCanvas new! !

!Canvas class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:14'!
gtExampleWorldCanvas
	<gtExample>
	<label: 'Canvas: World'>
	
	^ Canvas new! !

!Canvas class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:14'!
gtExampleWorldCanvasWithAlpha
	<gtExample>
	<label: 'Canvas: World+ALpha'>
	
	^ (AlphaBlendingCanvas on: Canvas new)	
		alpha: 0.3! !

!Canvas class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:14'!
gtExampleWorldCanvasWithShadow
	<gtExample>
	<label: 'Canvas: World+Shadow'>
	
	^ (ShadowDrawingCanvas on: Canvas new)
		shadowColor: (Color black alpha: 0.5)! !

!Canvas methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/14/2014 06:51'!
gtInspectorFormIn: composite
	<gtInspectorPresentationOrder: 40>
	^ self form gtInspectorFormIn: composite ! !

!HelpTopic class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:01'!
gtExampleComposedTopic
	<gtExample>
	|rootTopic|
	
	rootTopic := HelpTopic new
		title: 'ExampleTopic';
		contents: 'I am an example topic'.
	rootTopic addSubtopic: (HelpTopic new
		title: 'Subtopic1';
		contents: 'I am an subtopic topic').
	rootTopic addSubtopic: (HelpTopic new
		title: 'Subtopic2').
		
	^ rootTopic
		! !

!HelpTopic class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:00'!
gtExampleSingleTopic
	<gtExample>
	
	^ HelpTopic new
		title: 'ExampleTopic';
		contents: 'I am an example topic'
		! !

!HelpTopic methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TorstenBergmann 8/11/2015 19:11'!
gtInspectorActionOpenHelpBrowser
	<gtInspectorAction>
	
	^ GLMGenericAction new
		action: [ HelpBrowser openOn: self ];
		icon: Smalltalk ui icons bookIcon;
		title: 'Browse'! !

!HelpTopic methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/6/2015 10:36'!
gtInspectorContentsIn: composite
	<gtInspectorPresentationOrder: 40>
	
	composite text
		title: 'Contents';
		display: [ self contents ];
		when: [ self contents notEmpty  ] ! !

!HelpTopic methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/6/2015 10:28'!
gtInspectorSubtopicsIn: composite
	<gtInspectorPresentationOrder: 50>

	composite tree
		shouldValidate: false;
		title: 'Subtopics';
		display: [ self subtopics ];
		children: [ :each | each subtopics ];
		when: [ self hasSubtopics ];
		format: #title! !

!ZnStringEntity class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleEmptyHtml
	<gtExample>
	<label: 'Empty HTML'>
	
	^ self html: ''! !

!ZnStringEntity class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleEmptyText
	<gtExample>
	<label: 'Empty text'>
	
	^ self text: ''! !

!ZnStringEntity class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleEmptyXml
	<gtExample>
	<label: 'Empty XML'>
	
	^ self xml: ''! !

!ZnStringEntity class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleHtml
	<gtExample>
	<label: 'HTML'>
	
	^ self html: '<p><b>Hello</b> <i>World<i></p>'! !

!ZnStringEntity class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleText
	<gtExample>
	<label: 'Text'>
	
	^ self text: 'Hello World'! !

!ZnStringEntity class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:09'!
gtExampleXml
	<gtExample>
	<label: 'XML'>
	
	^ self xml: '<message>Hello World</message>'! !

!ZnStringEntity methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 14:41'!
gtInspectorTextIn: composite
	<gtInspectorPresentationOrder: 30>
	composite rubricText
		title: 'Contents';
		format: self string! !

!KMRepository class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 3/26/2015 00:05'!
gtExampleDefault
	<gtExample>
	^ self default! !

!KMRepository methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/20/2014 21:53'!
gtInspectorGlobalsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Global keys';
		display: [ 
			self globalCategories
				flatCollect: [ :category | 
					category allEntries keymaps collect: [ :key | key -> category ] ]
				 ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!KMRepository methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 1/27/2015 20:59'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite table 
		title: 'Keys';
		display: [ 
			self categories values
				flatCollect: [ :category | 
					category allEntries keymaps collect: [ :key | key -> category ] ]
				 ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		column: 'Shortcut' evaluated: [ :assoc | assoc key shortcut gtDisplayString ] width: 120;
		column: 'Action' evaluated: [ :assoc | assoc key action gtDisplayString ];
		column: 'Description' evaluated: [ :assoc | assoc key description ];
		column: 'Category' evaluated: [ :assoc | '' ] tags: [ :assoc | assoc value name ifNil: [ #() ] ifNotNil: [ { assoc value name }]];
		send: #key! !

!GLMBrowser class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:02'!
gtExampleBasic
	<gtExample>
	^ GLMWrapper new! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 12/18/2013 05:46'!
gtInspectorBrowserIn: composite
	<gtInspectorPresentationOrder: 40>  
	^ (composite wrapper with: [ :w |
		w title: 'Live'.
		w show: [:a | a custom: self copy ] ]
		) startOn: self entity! !

!GLMBrowser methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 7/29/2014 11:01'!
gtInspectorTransmissionsIn: composite
	<gtInspectorPresentationOrder: 35>  
	^ composite list 
		title: 'Transmissions';
		display: [ self transmissions ]! !

!OrderedDictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:47'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: 'Items';
		display: [ self associations ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		selectionAct: [ :table |
			table rawSelection do: [ :assoc | self removeKey: assoc key ].
			table update ]
			entitled: 'Remove item(s)';
		selectionPopulate: #selection 
			entitled: 'Open key'
			with: [ :table | (table rawSelection collect: #key) gtInspectorInterestingObject ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | 
				selection isNil 
				ifTrue: [ nil ]
				ifFalse: [ selection size = 1  
					ifTrue: [ selection anyOne value ] 
					ifFalse: [ selection collect: #value ] ]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!Dictionary class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:15'!
gtExampleEmptyDictionary
	<gtExample>
	<label: 'Empty dictionary'>

	^ Dictionary new! !

!Dictionary class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:15'!
gtExampleOneElementDictionaryFrom: anEmptyDictionary
	<gtExample>
	<label: 'One element dictionary'>
	<depends: #gtExampleEmptyDictionary>
	
	anEmptyDictionary at: 4 put: 2.
	^ anEmptyDictionary! !

!Dictionary class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:15'!
gtExampleRemoveElementFrom: anEmptyDictionary
	<gtExample>
	<label: 'Remove element'>
	<depends: #gtExampleOneElementDictionaryFrom:>
	
	anEmptyDictionary removeKey: 4.
	^ anEmptyDictionary! !

!Dictionary class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:15'!
gtExampleTwoElementsDictionaryFrom: aDictionary
	<gtExample>
	<label: 'Two elements dictionary'>
	<depends: #gtExampleOneElementDictionaryFrom:>
	
	aDictionary at: #fourty put: 'two'.
	^ aDictionary! !

!Dictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'NicolaiHess 6/20/2015 00:50'!
gtInspectorItemsIn: composite
	^ (composite table)
		title: 'Items';
		display: [ self associations ];
		children: [ :each | 
			(each value isDictionary) 
				ifTrue: [ each value associations ] 
				ifFalse: [ (each value isArray and: [ each value allSatisfy: #isDictionary ])
						ifTrue: [ each value collectWithIndex: [:x :i | i -> x ] ]
						ifFalse: [ #() ] ] ];
		column: 'Key' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each key ];
		column: 'Value' 
			evaluated: [:each | GTObjectPrinter new asTruncatedTextFrom: each value ];
		selectionAct: [ :table |
			table rawSelection do: [ :assoc | self removeKey: assoc key ].
			table update ]
			entitled: 'Remove item(s)';
		selectionPopulate: #selection 
			entitled: 'Open key'
			with: [ :table | (table rawSelection collect: #key) gtInspectorInterestingObject ];
		beMultiple;
		withSmalltalkSearch;
		send: [ :selection | 
			selection isNil 
			ifTrue:[nil]
			ifFalse:[ (selection size = 1) 
				ifTrue: [ selection anyOne value ] 
				ifFalse: [ selection collect: #value ] ]];
		showOnly: 50;
		helpMessage: 'Quick selection field. Given your INPUT, it executes: self select: [:each | INPUT ]'! !

!Dictionary methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SeanDeNigris 8/11/2015 08:52'!
gtInspectorKeysIn: composite
	<gtInspectorPresentationOrder: 1>

	^ composite list
		title: 'Keys';
		display: [ self keys ]! !

!MetacelloProjectSpec class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:19'!
gtExampleMetacelloSpec
	<gtExample>
	<label: 'Metacello project reference'>
	
	^ (ConfigurationOfGTInspectorCore project version: #development) projects anyOne! !

!MetacelloProjectSpec methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 20:38'!
gtInspectorPackagesIn: composite
	<gtInspectorPresentationOrder: 40>
	self version gtInspectorPackagesIn: composite! !

!MetacelloProjectSpec methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 11/23/2014 20:36'!
gtInspectorProjectsIn: composite
	<gtInspectorPresentationOrder: 40>
	self version gtInspectorProjectsIn: composite! !

!ZnRequest class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:27'!
gtExampleGetEmpty
	<gtExample>
	<label: 'Request message: GET <>'>
	
	^ self method: #GET url: ''! !

!ZnRequest class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:11'!
gtExampleGetLocalhost8080
	<gtExample>
	<label: 'Request message: GET http://localhost:8080'>
	
	^ self method: #GET url: 'http://localhost:8080'! !

!ZnRequest class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:11'!
gtExampleGetPharo
	<gtExample>
	<label: 'Request message: GET http://pharo.org'>
	
	^ self method: #GET url: 'http://pharo.org'! !

!ZnRequest class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 9/6/2015 17:10'!
gtExampleGetRoot
	<gtExample>
	<label: 'Request message: GET /'>
	
	^ self method: #GET url: '/'! !

!ZnRequest methodsFor: '*GT-InspectorExtensions-Core' stamp: 'SvenVanCaekenberghe 10/6/2014 15:18'!
gtInspectorRequestIn: composite
	<gtInspectorPresentationOrder: 25>
	(self requestLine gtInspectorTextIn: composite)
		title: 'Request'! !

!KMCategory class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 16:16'!
gtExampleCategoryWithEntry
	<gtExample>
	^ (self named: '1 Entry') 
		addKeymapEntry: (KMKeymap 
								named: #FooBar 
								shortcut: $a asKeyCombination
								action: [ ]);
		yourself! !

!KMCategory class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 3/27/2015 15:56'!
gtExampleEmptyCategory
	<gtExample>
	^ self named: 'Empty Example'! !

!KMCategory methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 1/20/2014 08:20'!
gtDisplayOn: stream
	^ stream nextPutAll: self name asString! !

!KMCategory methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TudorGirba 2/9/2014 22:05'!
gtInspectorMappingsIn: composite
	<gtInspectorPresentationOrder: 40>
	composite list
		title: 'Keys';
		display: [ self allEntries keymaps ];
		filterOn: [ :text :each | each gtDisplayString includesSubstring: text caseSensitive: false ];
		format: #gtDisplayString;
		when: [ self allEntries keymaps notEmpty ]! !

!Class class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:04'!
gtExampleClass
	<gtExample>
	^ self! !

!Object class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'StefanReichhart 4/9/2015 12:05'!
gtExampleBasic
	<gtExample>
	^ self new! !

!MCRepository class methodsFor: '*GT-InspectorExtensions-Core' stamp: 'AndreiChis 5/5/2015 14:51'!
gtDictionaryRepositoryExample
	<gtExample>
	^ MCDictionaryRepository new! !

!MCRepository methodsFor: '*GT-InspectorExtensions-Core' stamp: 'TorstenBergmann 4/13/2015 21:18'!
gtInspectorGoferReferencesIn: composite
    <gtInspectorPresentationOrder: 40>
      
	composite list
   	 	title: 'Gofer';
   	 	display: [ self goferReferences sorted ];
	   format: [:each | each name  asString ];
		icon: [ Smalltalk ui icons packageIcon ];
		act: [:com | com selection ifNotNilDo: [:each |
				Gofer new 
					repository: com entity;
					version: each name;
					load 				 
		 ]] 
		icon: Smalltalk ui icons downIcon entitled: 'Load'
			! !
